% Put it super early because of a lineno bug: https://github.com/latex-lineno/lineno/issues/5
\usepackage{mathtools,amsthm}


\setlength{\parindent}{0em}
\setlength{\parskip}{1ex plus 0.25ex minus 0.15ex}
\setlength{\listparindent}{0em}

\usepackage{ragged2e}

% \input{../../colorscheme}

% Use \dash for endash and \Dash for emdash
\usepackage{dash}

% This is for putting figures inside a paragraph
% Example: \begin{wrapfigure}{r}{0.25\textwidth}\includegraphics[width=0.2\textwidth]{xxx.png}\end{wrapfigure}
\usepackage{wrapfig} \setlength{\rightskip}{0pt plus 200pt} % see http://newsgroup.derkeiler.com/Archive/Comp/comt.text.tex/2010-10/msg00471.html


\DeclareGraphicsRule{*}{mps}{*}{}
\newcommand{\centergraphic}[2][]{\begin{center}\includegraphics[#1]{#2}\end{center}}

% This is for putting figures inside a paragraph
% Example: \begin{wrapfigure}{r}{0.25\textwidth}\includegraphics[width=0.2\textwidth]{xxx.png}\end{wrapfigure}
\usepackage{wrapfig} \setlength{\rightskip}{0pt plus 200pt} % see http://newsgroup.derkeiler.com/Archive/Comp/comt.text.tex/2010-10/msg00471.html

% Use \dash for endash and \Dash for emdash
\usepackage{dash}

\usepackage{xparse}% http://ctan.org/pkg/xparse
% \NewDocumentCommand{\reff}{s m}{%
%   \IfBooleanTF{#1}% Check for starred variant
%     {\beamer@origref{#2}}% \reff*
%     {\hyperlink{#2}{\beamer@origref{#2}}}% \reff
% }
\NewDocumentCommand{\reff}{s m}{%
  \beamer@origref{#2}
  % \IfBooleanTF{#1}% Check for starred variant
  %   {\beamer@origref{#2}}% \reff*
  %   {\hyperlink{#2}{\beamer@origref{#2}}}% \reff
}
\AtBeginDocument{\makeatletter
\let\ref\reff  % make all references like \ref*{..}
\makeatother}

% {\def\protect{\global\let\YesIMeanThisRef}\ref}
% \AtBeginDocument{\def\ref{\protect\YesIMeanThisRef}}

% Reduce the space between the frame title and the top of frame text
\addtobeamertemplate{frametitle}{\vspace*{0pt}}{\vspace*{-6pt}}
% \setbeamerfont{frametitle}{size=\LARGE}

% Make \section{..} show a page all alone.
\AtBeginSection{
\begin{frame}
\vfill
\begin{center}
\structure{\LARGE \insertsection}
\end{center}
\vspace*{14ex}
\end{frame}
}

% ========== parenum ================
% Beamer is a big ball of mud.
% I want to define parenum, so that when I pull it from the main doc,
% it will do the right thing.  But Beamer has to have its own list commands,
% and other packages are destroyed.  Sigh.  So I apparently cannot use
% either enumitem or paralist.  Sigh.  SO I googled how to change 
% numbering in Beamer.  It is hard.  Sigh.  Beamer SUUUUUUUUUCKS.

% ========== enumitem =============
% \usepackage[inline]{enumitem}
% % parenum
% %  Enumerate inside a paragraph
% \newenvironment{parenum}{%
%   \begin{enumerate*}[label=(\arabic*),
%                      before=\unskip{\nobreak\ \mbox{}}]%
% }{%
%   \end{enumerate*}
% }
% asparadesc  A description environment
\definecolor{labelcolor}{rgb}{.318, .277, .718}  % #5147B7
\definecolor{labelnumcolor}{rgb}{.773, .769, .812}  % #C5C4CF
% \usepackage[olditem,oldenum]{paralist}
% \renewcommand*\paradescriptionlabel[1]{%
% \normalfont\bfseries\color{labelcolor} #1}
% \newenvironment{parenum}{%
%   \begin{inparaenum}[(1)]}
% {%
%   \end{inparaenum}
% }

\newenvironment{parenum}{%
 \setbeamertemplate{enumerate item}{(\arabic{enumi})}
 \let\par\relax%
 \setcounter{enumi}{1}%
 \def\item{\usebeamertemplate{enumerate  item} \stepcounter{enumi}}%
 \leavevmode%
}{%
 \setcounter{enumi}{0}%
}
% thmdescription
% An description list inside of a theorem, or lemma, or definition
\newenvironment{thmdescription}{%
  \begin{description}[xxx]
}{%
 \end{description}
}

\newenvironment{thmparts}{%
 \setbeamertemplate{enumerate item}{(\arabic{enumi})}
 % \let\par\relax%
 \setcounter{enumi}{1}%
 \def\item{\usebeamertemplate{enumerate  item} \stepcounter{enumi}}%
 \leavevmode%
}{%
 \setcounter{enumi}{0}%
}


% For text in header of tables
% already defined \newcommand{\tabulartext}[1]{\textit{#1}}

% Make verbatim quotes correct
\usepackage{upquote}  

% This must come before listings: https://github.com/gpoore/pythontex/issues/61
\usepackage[makestderr]{pythontex}

\usepackage{listings}
\lstset{ 
%   backgroundcolor=\color{white},   % choose the background color; you must add \usepackage{color} or \usepackage{xcolor}; should come as last argument
  basicstyle=\footnotesize,        % the size of the fonts that are used for the code
  breakatwhitespace=false,         % sets if automatic breaks should only happen at whitespace
  breaklines=false,                 % sets automatic line breaking
  captionpos=b,                    % sets the caption-position to bottom
%   commentstyle=\color{mygreen},    % comment style
  columns=fullflexible,              % banish insane letter spacing.
%   deletekeywords={...},            % if you want to delete keywords from the given language
%  escapeinside={\%*}{*)},          % if you want to add LaTeX within your code
%   extendedchars=true,              % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
%   frame=single,	                   % adds a frame around the code
%   keepspaces=true,                 % keeps spaces in text, useful for keeping indentation of code (possibly needs columns=flexible)
%   keywordstyle=\color{blue},       % keyword style
%   language=Octave,                 % the language of the code
%   morekeywords={*,...},            % if you want to add more keywords to the set
%   numbers=left,                    % where to put the line-numbers; possible values are (none, left, right)
%   numbersep=5pt,                   % how far the line-numbers are from the code
%   numberstyle=\tiny\color{mygray}, % the style that is used for the line-numbers
%   rulecolor=\color{black},         % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. comments (green here))
  showspaces=false,                % show spaces everywhere adding particular underscores; it overrides 'showstringspaces'
  showstringspaces=false,          % underline spaces within strings only
  showtabs=false,                  % show tabs within strings adding particular underscores
%   stepnumber=2,                    % the step between two line-numbers. If it's 1, each line will be numbered
%   stringstyle=\color{mymauve},     % string literal style
%   tabsize=2,	                   % sets default tabsize to 2 spaces
%   title=\lstname                   % show the filename of files included with \lstinputlisting; also try caption instead of title
}
\lstset{basicstyle=\footnotesize,commentstyle=\color{blue},
        backgroundcolor=\color[HTML]{FBF5BB}}
% \newcommand\codeinline{\lstinline[basicstyle=\smaller\ttfamily]}
\newcommand\codeinline[1]{\texttt{#1}}


% \usepackage{../../contentmacros}  % dir relative to source, not this file
\usepackage{jh}
% Vectors
\usepackage[f]{esvect}  % extensible vectors
\renewcommand{\vec}[1]{\vv{#1}}

\renewcommand{\proofname}{\textsc{Pf}}
\renewcommand\qedsymbol{\rule{0.3em}{1.5ex}}


\newcommand{\hdrcmd}[1]{\textsc{#1}\hspace*{0.5em}}
\newcommand{\Ex}{\hdrcmd{Example}}
\newcommand{\Df}{\hdrcmd{Definition}}
\newcommand{\Tm}{\hdrcmd{Theorem}}
\newcommand{\Lm}{\hdrcmd{Lemma}}
\newcommand{\Rm}{\hdrcmd{Remark}}
\newcommand{\Co}{\hdrcmd{Corollary}}
\newcommand{\Pf}{\hdrcmd{Proof}}


% Change the default thickness of the underbars.
% https://tex.stackexchange.com/a/559081/339
\usepackage{xpatch}
\MHInternalSyntaxOn
\xpatchcmd\upbracketfill
  {\sbox\z@{$\braceld$}\edef\l_MT_bracketheight_fdim{\the\ht\z@}}
  {\edef\l_MT_bracketheight_fdim{.6pt}}
  {}{\fail}

\xpatchcmd\downbracketfill
  {\sbox\z@{$\braceld$}\edef\l_MT_bracketheight_fdim{\the\ht\z@}}
  {\edef\l_MT_bracketheight_fdim{.6pt}}
  {}{\fail}
\MHInternalSyntaxOff



